package automata.Ant;

import automata.Automata;

public class Ant extends Automata{
	private int x = 0;
	private int y = 0;

	private int antColor = 255;

	private static final int NORTH = 0;
	private static final int SOUTH = 1;
	private static final int EAST  = 2;
	private static final int WEST  = 3;

	private int direction = NORTH;

	public void reset(){
		nullBoard();
		x = width / 2;
		y = height / 2;
		direction = NORTH;
	}

	public void step(){
		if(board[x][y] == 0)
			board[x][y] = antColor;
		else
			board[x][y] = 0;

		switch(direction){
			case NORTH:
				y--;
				break;
			case SOUTH:
				y++;
				break;
			case EAST:
				x++;
				break;
			case WEST:
				x--;
				break;
			default:
				break;
		}

		if(x >= width)
			x = 0;
		else if(x < 0)
			x = width - 1;

		if(y >= height)
			y = 0;
		else if(y < 0)
			y = height - 1;

		if(board[x][y] == 0){
			switch(direction){
				case NORTH:
					direction = WEST;
					break;
				case SOUTH:
					direction = EAST;
					break;
				case EAST:
					direction = NORTH;
					break;
				case WEST:
					direction = SOUTH;
					break;
				default:
					break;
			}
		}
		else{
			switch(direction){
				case NORTH:
					direction = EAST;
					break;
				case SOUTH:
					direction = WEST;
					break;
				case EAST:
					direction = SOUTH;
					break;
				case WEST:
					direction = NORTH;
					break;
				default:
					break;
			}
		}
	}
}

// vim:noet:ts=3
