package automata.Life;

import automata.Automata;

public class Life extends Automata{
	public void reset(){
		randomBoard();
	}

	public void step(){
		int oldBoard[][] = new int[width][height];
		for(int i = 0; i < width; i++)
			System.arraycopy(board[i], 0, oldBoard[i], 0, height);

		for(int i = 0; i < width; i++){
			for(int j = 0; j < height; j++){
				int count = 0;
				int x0 = i - 1;
				int x1 = i + 1;
				int y0 = j - 1;
				int y1 = j + 1;

				if(x0 < 0)
					x0 = width - 1;
				if(x1 >= width)
					x1 = 0;
				if(y0 < 0)
					y0 = height - 1;
				if(y1 >= height)
					y1 = 0;

				if(oldBoard[x0][j] > 0)
					count++;
				if(oldBoard[x0][y0] > 0)
					count++;
				if(oldBoard[x0][y1] > 0)
					count++;
				if(oldBoard[i][y0] > 0)
					count++;
				if(oldBoard[i][y1] > 0)
					count++;
				if(oldBoard[x1][j] > 0)
					count++;
				if(oldBoard[x1][y0] > 0)
					count++;
				if(oldBoard[x1][y1] > 0)
					count++;

				if(count < 2 || count > 3)
					board[i][j] = 0;
				else if(count == 3 && oldBoard[i][j] == 0)
					board[i][j] = 1;
				else if(oldBoard[i][j] > 0)
					board[i][j]++;
			}
		}
	}
}

// vim:noet:ts=3
