package automata.Simple;

import automata.Automata;

public class Simple extends Automata{
	private int color = 255;
	private int row = 0;

	private int states = 2;
	private int neighbors = 3;
	private int halfNeighbors = 1;

	private int ruleCount = 8;
	private int [] rules = null;

	public Simple(){
		super();

		ruleCount = 1;
		for(int i = 0; i < neighbors; i++){
			if(ruleCount > 32768){
				ruleCount = 8;
				break;
			}
			ruleCount *= states;
		}

		rules = new int[ruleCount];
		for(int i = 1; i < (ruleCount - 1); i++)
			rules[i] = 1;
		rules[0] = rules[ruleCount - 1] = 0;

		halfNeighbors = neighbors / 2;
	}

	public void reset(){
		nullBoard();
		board[width / 2][0] = color;
		row = 0;
	}

	public void step(){
		row++;
		if(row >= height){
			row = height - 1;
			for(int i = 0; i < (height - 1); i++)
				for(int j = 0; j < width; j++)
					board[j][i] = board[j][i + 1];
		}

		for(int i = 0; i < width; i++){
			int left = i - halfNeighbors;
			if(left < 0)
				left += width;

			int right = i + halfNeighbors;
			if(right >= width)
				right -= width;

			int lastRow = row - 1;
			int k = 0;

			if(left < right){
				for(int j = left; j <= right; j++)
					k = states * k + (board[j][lastRow] > 0 ? 1 : 0);
			}
			else{
				for(int j = left; j < width; j++)
					k = states * k + (board[j][lastRow] > 0 ? 1 : 0);
				for(int j = 0; j <= right; j++)
					k = states * k + (board[j][lastRow] > 0 ? 1 : 0);
			}

			board[i][row] = (rules[k] > 0 ? color : 0);
		}
	}
}

// vim:noet:ts=3
