package automata.Stars;

import java.util.Random;

public class Star{
	private static Random random = new Random(System.currentTimeMillis());

	private double radius = 0;
	private double delta = 0;
	private double angle = 0;
	private int x = 0;
	private int y = 0;

	private int cx = 0;
	private int cy = 0;

	public Star(int sx, int sy){
		cx = sx;
		cy = sy;
		delta = random.nextDouble();
		angle = random.nextDouble() * 2 * Math.PI;
	}

	public void step(int width, int height){
		radius += delta;
		x = (int)(Math.cos(angle) * radius) + cx;
		y = (int)(Math.sin(angle) * radius) + cy;
		if(x >= width || x < 0 || y >= width || y < 0){
			x = width / 2;
			y = height / 2;
			radius = 0;
		}
	}

	public int getX(){
		return x;
	}

	public int getY(){
		return y;
	}
}

// vim:noet:ts=3
